#include <Servo.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

// For these LCD controls to work you MUST replace the standard LCD library from...
// https://github.com/marcoschwartz/LiquidCrystal_I2C
// Direct download https://github.com/marcoschwartz/LiquidCrystal_I2C/archive/master.zip
// Your project will not compile until this is done.
LiquidCrystal_I2C lcd(0x27, 16, 2); // set the LCD address for a 16 chars and 2 line display

Servo servo_motor_left; // create servo object to control a servo
Servo servo_motor_right;

const int l_ang[10] = {180, 150, 135, 120, 105, 90, 75, 60, 45, 30};
const int r_ang[10] = {0, 30, 45, 60, 75, 90, 105, 120, 135, 150};
int x;
int y;
int ans;
int guess;
unsigned seed;
int prev;
bool wait;

void setup() { // put your setup code here, to run once:
  Serial.begin(9600);
  seed = analogRead( A0 );
  srand(seed);
  Serial.print("seed = ");
  Serial.print(seed);
  Serial.println();
  pinMode( 4 , INPUT);
  lcd.init (); // initialize the lcd
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.setBacklight(HIGH);
  lcd.print("Initializing");
  servo_motor_left.attach(11);
  delay(2000);
  servo_motor_right.attach(5);
  delay(2000);
  if (digitalRead(4) == 1) {
    lcd.setBacklight(HIGH);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("entering");
    lcd.setCursor(0, 1);
    lcd.print("setting mode");
    for (int i = 0; i < 3; i++) {
      delay(350);
      lcd.print(".");
    }
    delay(2000);
    for (int i = 0; i <= 9; i++) {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("number: ");
      lcd.print(i);
      servo_motor_left.write( l_ang[i] );
      servo_motor_right.write( r_ang[i] );

      //    lcd.setBacklight(HIGH);
      while (1) {
        if (digitalRead(4) == 1) {
          break;
        }
      }
      lcd.clear();

      delay(500);

    }
    lcd.print("exiting...");


  }

  delay(500);


  lcd.backlight();

}

void loop() { // put your main code here, to run repeatedly:
  x = rand() % 9 + 1;
  y = rand() % 9 + 1;
  analogWrite(10, 0);
  analogWrite(9, 0);
  Serial.print("x = ");
  Serial.print(x);
  Serial.print("\ty = ");
  Serial.print(y);
  Serial.println();
  lcd.clear();
  lcd.setBacklight(LOW);
  servo_motor_left.write( l_ang[x] );
  delay(1000);
  servo_motor_right.write( r_ang[y] );
  //  delay(200);
  ans = x * y;
  wait = 1;
  lcd.setBacklight(HIGH);
  prev = 100;
  int brtn = 0;
  bool up = 1;

  while (wait = 1) {
    delay( 10 );
    if (brtn >= 250) up = 0;
    if (brtn == 0) up = 1;
    if (up == 1) brtn += 1;
    else brtn -= 1;
    analogWrite(6, brtn);
    if (digitalRead( 4 ) == 1) {
      break;
    }
    guess = map ( analogRead( A4 ) , 0 , 1021 , 0 , 100 );
    if (guess != prev) {
      Serial.print("choose: ");
      Serial.print(guess);
      Serial.println();
      lcd.setCursor(13, 1);
      lcd.print(x);
      lcd.print("*");
      lcd.print(y);
      lcd.print("=?");
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print( "Enter the answer" );
      lcd.setCursor(0, 1);
      lcd.print( guess ); // Print a message to the LCD.
//      lcd.setCursor(11, 1);
//      lcd.print(x);
//      lcd.print("*");
//      lcd.print(y);
//      lcd.print("=?");
      prev = guess;
    }
  }
  analogWrite(6, 0);
  Serial.print(guess);
  Serial.println();
  Serial.print(x * y);
  Serial.println();
  if (x * y == guess) {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("CONGRATULATIONS!");
    analogWrite(9, 255);
    tone(8, 2000, 125);
    delay(125);
    tone(8, 1740, 130);
    delay(150);
    tone(8, 2000, 125);
    delay(125);
    tone(8, 1740, 200);
  }
  else {
    analogWrite(10, 255);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("You're wrong!");
    lcd.setCursor(0, 1);
    lcd.print(x);
    lcd.print("*");
    lcd.print(y);
    lcd.print("=");
    lcd.print(x * y);
    tone(8, 250, 200);
    delay(230);
    tone(8, 250, 1200);

  }

  delay(3000);
}
